#include "bla2.h"

static int col8[8] = { 0x000000, 0x0000ff, 0x00ff00, 0x00ffff, 0xff0000, 0xff00ff, 0xffff00, 0xffffff };

STATIC int bla_xcol(int c)
{
	if (0x00000000 <= c && c <= 0x0000000f)
		return col8[c & 7];
	if (0x00000040 <= c && c <= 0x0000007f)
		return (c & 3) * 0x55 | ((c >> 2) & 3) * 0x5500 | ((c >> 4) & 3) * 0x550000;
	return c & 0x00ffffff;
}

STATIC void bla_echr(bla_ECWin *ecw, int x, int y, int ch, int c, int b)
{
	int cc = bla_xcol(c), bb = bla_xcol(b);
	if (0 <= x && x * 16 < ecw->win->xsiz && 0 <= y && y * 16 < ecw->win->ysiz) {
		ecw->cb[y * 256 + x * 2 + 0] = ch;
		ecw->cb[y * 256 + x * 2 + 1] = c;
		int i, j;
		const char *p = &ecw->font[ch * 256];
		x *= 16;
		y *= 16;
		int *q = ecw->win->buf + x + y * ecw->win->xsiz;
		for (j = 0; j < 16; j++) {
			for (i = 0; i < 16; i++) {
				q[i] = bb;
				if (p[i] == '*')
					q[i] = cc;
			}
			p += 16;
			q += ecw->win->xsiz;
		}
	}
}

STATIC void bla_scroll1(bla_ECWin *ecw, int d)
{
	int x, y, *b = ecw->win->buf, xs = ecw->win->xsiz, ys;
	unsigned char *gcb = ecw->cb;
	if (d == 0) {	/*  */
		for (y = 0; y < ecw->win->ysiz; y++) {
			for (x = 0; x < xs - 16; x++)
				b[x] = b[x + 16];
			b += xs;
		}
		xs = (xs >> 4) - 1;
		ys = ecw->win->ysiz >> 4;
		for (y = 0; y < ys; y++) {
			for (x = 0; x < xs; x++) {
				gcb[y * 256 + x * 2 + 0] = gcb[y * 256 + x * 2 + (+2 + 0)];
				gcb[y * 256 + x * 2 + 1] = gcb[y * 256 + x * 2 + (+2 + 1)];
			}
		}
	}
	if (d == 1) {	/*  */
		for (y = 0; y < ecw->win->ysiz; y++) {
			for (x = xs - 1; x >= 16; x--)
				b[x] = b[x - 16];
			b += xs;
		}
		xs >>= 4;
		ys = ecw->win->ysiz >> 4;
		for (y = 0; y < ys; y++) {
			for (x = xs - 1; x >= 1; x--) {
				gcb[y * 256 + x * 2 + 0] = gcb[y * 256 + x * 2 + (-2 + 0)];
				gcb[y * 256 + x * 2 + 1] = gcb[y * 256 + x * 2 + (-2 + 1)];
			}
		}
	}
	if (d == 2) {	/*  */
		int xys = ecw->win->xsiz * (ecw->win->ysiz - 16);
		xs <<= 4;
		for (y = 0; y < xys; y++)
			b[y] = b[y + xs];
		xys = ((ecw->win->ysiz >> 4) - 1) * 128;
		for (y = 0; y < xys; y++) {
			gcb[y * 2 + 0] = gcb[y * 2 + (+256 + 0)];
			gcb[y * 2 + 1] = gcb[y * 2 + (+256 + 1)];
		}
	}
	if (d == 3) {	/*  */
		int xys = ecw->win->xsiz * (ecw->win->ysiz - 16);
		xs <<= 4;
		for (y = xys - 1; y >= xs; y--)
			b[y] = b[y - xs];
		xys = ((ecw->win->ysiz >> 4) - 1) * 128;
		for (y = xys - 1; y >= 128; y--) {
			gcb[y * 2 + 0] = gcb[y * 2 + (-256 + 0)];
			gcb[y * 2 + 1] = gcb[y * 2 + (-256 + 1)];
		}
	}
}
