struct HrbCons {
	char *buf, lbuf[1024];
	int win, xsz, ysz, cx, cy, col, bcol, lbp;
	char needRefresh;
};

STATIC void *hrbCons_malloc(int sz)
{
	return api_malloc(sz);
}

STATIC void hrbCons_free(void *p, int sz)
{
	api_free(p, sz);
}

STATIC struct HrbCons *hrbCons_open(struct HrbCons *w, char *b, int xsz, int ysz, const char *title)
{
	if (b == 0)
		b = hrbCons_malloc((xsz * 8 + 16) * (ysz * 16 + 37) * sizeof (char));
	if (w == 0)
		w = hrbCons_malloc(sizeof (struct HrbCons));
	w->buf = b;
	w->xsz = xsz;
	w->ysz = ysz;
	w->cx = w->cy = 0;
	w->col = 7;
	w->bcol = 0;
	w->needRefresh = 0;
	w->win = api_openwin(b, xsz * 8 + 16, ysz * 16 + 37, -1, (char *) title);
	api_boxfilwin(w->win, 6, 27, xsz * 8 + 9, ysz * 16 + 30, 0);
	api_boxfilwin(w->win, 8, 29, xsz * 8 + 7, ysz * 16 + 28, w->bcol);
	return w;
}

STATIC void hrbCons_puts(struct HrbCons *w, const char *s, int l)
{
	int i, c, nr = w->needRefresh;
	for (i = 0; i < l; i++) {
		c = s[i];
		if (c == '\0') break;
		if (c == '\n') goto newline;
		if (c == '\r') { w->cx = 0; continue; }
		if (c == '\t') {
			w->cx = (w->cx + 8) & -8;
			goto testcxcy;
		}
		if (c == '\b') {
			if (w->cx + w->cy > 0) {
				w->cx--;
				if (w->cx < 0) {
					w->cx = w->xsz - 1;
					w->cy--;
				}
			}
			continue;
		}
		api_putstrwin(w->win + nr, w->cx * 8 + 8, w->cy * 16 + 29, w->col, 1, (char *) &c);
		w->cx++;
testcxcy:
		if (w->cx >= w->xsz) {
newline:
			w->cx = 0;
			w->cy++;
			if (w->cy >= w->ysz) {
				w->cy--;
#if 0
				int x, y;
				for (y = 29; y < w->ysz * 16 + 29 - 16; y++) {	// 	ꂪx.
					for (x = 8; x < w->xsz * 8 + 8; x++)
						w->buf[y * (w->xsz * 8 + 16) + x] = w->buf[(y + 16) * (w->xsz * 8 + 16) + x];
				}
#elif 1
				int c1 = (w->ysz * 16 + 29 - 16) * (w->xsz * 2 + 4), *b1 = (int *) w->buf, *b0 = b1 + 16 * (w->xsz * 2 + 4);
				for (c = 29 * (w->xsz * 2 + 4); c < c1; c += 2) {	// ܂܂}Vɂ͂Ȃ.
					b1[c]     = b0[c];
					b1[c + 1] = b0[c + 1];
				}
#endif
				api_boxfilwin(w->win + 1, 8, w->cy * 16 + 29, w->xsz * 8 + 7, w->ysz * 16 + 28, w->bcol);
				if (w->needRefresh == 0)
					api_refreshwin(w->win, 8, 29, w->xsz * 8 + 8, w->ysz * 16 + 29);
			}
		}
	}
}

STATIC void hrbCons_putCur(struct HrbCons *w, int sw)
{
	api_boxfilwin(w->win, w->cx * 8 + 8, w->cy * 16 + 29, w->cx * 8 + 15, w->cy * 16 + (29 + 15), w->bcol);
	if (sw != 0)
		api_putstrwin(w->win, w->cx * 8 + 8, w->cy * 16 + 29, w->col, 1, "_");
}

STATIC void hrbCons_needRefresh(struct HrbCons *w)
{
	if (w->needRefresh != 0) {
		api_refreshwin(w->win, 8, 29, w->xsz * 8 + 8, w->ysz * 16 + 29);
		w->needRefresh = 0;
	}
}
