//////////////////////////////////////////////////////////////////////////////// KStringId

typedef struct KStringId_Elmt_ {
	KInt l;
	const char *p;
	KUInt h;
	KInt n;
} KStringId_Elmt;

typedef struct KStringId_ {
	KMemPool *mp;
	KIndexDict3 *dict, *dict0;
	KInt *n, *n0, f;
	void *cbf, *opt;
	KVarArea *va, *va0;
} KStringId;

STATIC KStringId *KStringId_initSub(KStringId *w)
{
	if (w->dict == 0)
		w->dict = KIndexDict3_init(0, w->mp, 0, 0);
	if (w->n == 0)
		w->n = KMemPool_allocC(w->mp, sizeof (KInt));
	if (w->va == 0)
		w->va = KVarArea_init(0, w->mp, 0);
	return w;
}

STATIC KStringId_Elmt *KStringId_addSub(KStringId *w, KInt l, const char *p, KUInt h)
{
	if ((w->f & 1) != 0) {
		char *q = (char *) KMemPool_alloc(w->mp, l + 1);
		memcpy(q, p, l);
		q[l] = '\0';
		p = q;
	}
	KStringId_Elmt *e = KMemPool_alloc(w->mp, sizeof (KStringId_Elmt));
	e->l = l;
	e->p = p;
	e->h = h;
	e->n = *w->n;
	(*w->n)++;
	return e;
}

STATIC KInt KStringId_search0(KStringId *w, KStringId_Elmt *k)
{
	KStringId_Elmt *d = (KStringId_Elmt *) KIndexDict3_search0(w->dict, k, k->h);
	if (d != 0)
		return d->n;
	return -1;
}

STATIC KInt KStringId_search1(KStringId *w, KStringId_Elmt *k)
{
	KStringId_Elmt *d = (KStringId_Elmt *) KIndexDict3_search0(w->dict, k, KIndexDict3_hsh((void *) k));
	if (d != 0)
		return d->n;
	return -1;
}

STATIC KStringId *KStringId_init(KStringId *w, KMemPool *mp, KInt f, KIndexDict3 *dict, KInt *n, KVarArea *va)
{
	w = KMemPool_allocP0(mp, sizeof (KStringId), w);
	w->mp = mp;
	w->dict = w->dict0 = dict;
	w->n = w->n0 = n;
	w->va = w->va0 = va;
	w->f = f;
	w->cbf = w->opt = 0;
	return KStringId_initSub(w);
}

STATIC void *KStringId_dest(KStringId *w)
{
	if (w->dict0 == 0 && w->va0 == 0) {
		KInt i;
		for (i = 0; i < w->va->s; i += sizeof (KStringId_Elmt *)) {
			KStringId_Elmt *e = *(KStringId_Elmt **) (w->va->p + i);
			if (e != 0) {
				if ((w->f & 1) != 0)
					KMemPool_free(w->mp, e->l + 1, (void *) e->p);
				KMemPool_free(w->mp, sizeof (KStringId_Elmt), e);
			}
		}
	}
	if (w->dict0 == 0)
		KIndexDict3_destFr(w->dict);
	if (w->n0 == 0)
		KMemPool_free(w->mp, sizeof (KInt), w->n);
	if (w->va0 == 0)
		KVarArea_destFr(w->va);
	return w;
}

STATIC void KStringId_destFr(KStringId *w)
{
	KMemPool_free(w->mp, sizeof (KStringId), KStringId_dest(w));
}

STATIC KStringId *KStringId_initAd(KStringId *w, KMemPool *mp, KInt f, KIndexDict3 *dict, KInt *n, KVarArea *va)
{
	w = KStringId_init(w, mp, f, dict, n, va);
	KMemPool_addDest(mp, KStringId_dest, w, 0);
	return w;
}

STATIC KStringId_Elmt *KStringId_getStr(KStringId *w, KInt i)
{
	return KVarArea_getPtrIdx(w->va, i);
}

STATIC KInt KStringId_getId0LH(KStringId *w, KInt l, const char *s, KUInt h)
{
	KStringId_Elmt k;
	k.l = l;
	k.p = s;
	k.h = h;
	return KStringId_search0(w, &k);
}

STATIC KInt KStringId_getId0L(KStringId *w, KInt l, const char *s)
{
	KStringId_Elmt k;
	k.l = l;
	k.p = s;
	return KStringId_search1(w, &k);
}

STATIC KInt KStringId_getId0(KStringId *w, const char *s)
{
	KStringId_Elmt k;
	k.l = strlen(s);
	k.p = s;
	return KStringId_search1(w, &k);
}

STATIC KInt KStringId_getId1L(KStringId *w, KInt l, const char *s)
{
	KUInt h = kfnvU(s, l);
	KStringId_Elmt k;
	k.l = l;
	k.p = s;
	k.h = h;
	KInt i = KStringId_search1(w, &k);
	if (i < 0) {
		i = *w->n;
		KStringId_Elmt *e = KStringId_addSub(w, l, s, h);
		KIndexDict3_ins(w->dict, e);
		KVarArea_reserveC(w->va, *w->n * sizeof (KStringId_Elmt *));
		w->va->s = *w->n * sizeof (KStringId_Elmt *);
		((KStringId_Elmt **) w->va->p)[i] = e;
		if (w->cbf != 0)
			((void (*)(KStringId *, int)) w->cbf)(w, i);
	}
	return i;
}

STATIC KInt KStringId_getId1(KStringId *w, const char *s)
{
	return KStringId_getId1L(w, strlen(s), s);
}

STATIC KStringId *KStringId_ins(KStringId *w, const char *s)
{
	KInt i;
	for (i = 0; s[i] != 0; ) {
		if (s[i] == ' ' || s[i] == '\t' || s[i] == '\n' || s[i] == '\r') {
			i++;
			continue;
		}
		KInt l = i + 1;
		while (s[l] != 0 && s[l] != ' ' && s[l] != '\t' && s[l] != '\n' && s[l] != '\r')
			l++;
		if ('0' <= s[i] && s[i] <= '9' && s[l - 1] == ':') {
			*w->n = kstrtoInt(l - i, &s[i], 0, 0);
			i = l;
			continue;
		}
		KInt n0 = *w->n;
		KStringId_getId1L(w, l - i, &s[i]);
		if (n0 >= *w->n)
			kerrorExit("KStringId_ins: over insert error: '%.*s'", (int) (l - i), &s[i]);
		i = l;
	}
	return w;
}

STATIC KStringId *KStringId_sort(KStringId *w)	// ̊֐݈̑Ӌ`͍̂ƂȂ.
{
	KIndexDict3_sort(w->dict);
	return w;
}

STATIC void KStringId_dump(KStringId *w)
{
	KInt i;
	for (i = 0; i < *w->n; i++) {
		KStringId_Elmt *e = KStringId_getStr(w, i);
		if (e->n == i && KStringId_getId0L(w, e->l, e->p) == i)
			printf("#%04d h=" KPRINTF_FORMAT("%08x", "%016I64x", "%016lx") "(%04x) [O] %.*s\n", (int) i, e->h, (int) (e->h & w->dict->n1), (int) e->l, e->p);
		else
			printf("#%04d h=" KPRINTF_FORMAT("%08x", "%016I64x", "%016lx") "(%04x) [X] %.*s n=%d getId=%d\n", (int) i, e->h, (int) (e->h & w->dict->n1), (int) e->l, e->p, (int) e->n, (int) KStringId_getId0L(w, e->l, e->p));
	}
}

//////////////////////////////////////////////////////////////////////////////// KLexer

STATIC char *kinitChrTyp(char *t)
{
	int i;
	for (i = 0; i < 256;i++) {
		char c = 0;
		if (i == ' ' || i == '\t' || i == '\n' || i == '\r') c = 1;	// Xy[XA^uAs.
		if ('0' <= i && i <= '9') c = 2;	// .
		if ('a' <= i && i <= 'z') c = 3;	// ϐ̈ꕶڂɎg镶.
		if ('A' <= i && i <= 'Z') c = 3;
		if (strchr("_$@`#'\\", i) != 0) c = 3;	// At@xbgɏ鈵.
		if (i >= 0x80) c = 3;
		if (strchr("=+-*/!%&~^|<>?:.", i) != 0) c = 4;	// ʂ̋L.
		if (strchr("(){}[];,", i) != 0) c = 5;	// 1ō\L.
		t[i] = c;
	}
	return t;
}

STATIC KInt ksearchToken0(const unsigned char *s, KInt i, KInt i1, const char *chrTyp)
{
	while (i < i1) {
		if (chrTyp[(int) s[i]] == 1) {
			i++;
			continue;
		}
		if (s[i] == '/' && s[i + 1] == '*') {
			KInt n = 1, i2 = i1 - 1;
			do {
				i++;
				if (s[i] == '/' && s[i + 1] == '*') n++;
				if (s[i] == '*' && s[i + 1] == '/') n--;
			} while (n > 0 && i < i2);
			i += 2;
			continue;
		}
		if (s[i] == '/' && s[i + 1] == '/') {
			while (i < i1 && s[i] != '\n')
				i++;
			continue;
		}
		if (s[i] == '`') {
			while (i < i1 && chrTyp[(int) s[i]] != 1)
				i++;
			continue;
		}
		break;
	}
	return i;
}

STATIC KInt ksearchToken1(const unsigned char *s, KInt i, KInt i1, const char *chrTyp)
{
	KInt j = i + 1;
	if (i >= i1) return -1;
	if (s[i] == 0x22 || s[i] == 0x27) {
		while (s[j] != s[i] && j < i1 && s[j] != '\n') {
			if (s[j] == '\\' && (s[j + 1] == s[i] || s[j + 1] == '\\'))
				j++;
			j++;
		}
		if (s[j] == s[i])
			j++;
		return j;
	}
	int ct = chrTyp[(int) s[i]];
	if (ct == 5) {
		;
	} else if (ct == 4) {
		for (; j < i1 && chrTyp[(int) s[j]] == 4; j++);
	} else if (ct == 3) {
		for (; j < i1 && (chrTyp[(int) s[j]] == 2 || chrTyp[(int) s[j]] == 3); j++);
	} else if (ct == 2) {
		for (; j < i1 && (chrTyp[(int) s[j]] == 2 || chrTyp[(int) s[j]] == 3); j++) {
			if ((s[j] == 'e' || s[j] == 'E') && (s[j + 1] == '+' || s[j + 1] == '-'))
				j++;
		}
	} else
		j = -2;
	return j;

}

STATIC unsigned char *kupperCaseM(KInt l, unsigned char *s, const char *chrTyp)
{
	KInt i = 0;
	for (;;) {
		i = ksearchToken0(s, i, l, chrTyp);
		KInt j = ksearchToken1(s, i, l, chrTyp);
		if (j < 0) break;
		if (s[i] == 0x22 || s[i] == 0x27) {
			i = j;
		} else {
			while (i < j) {
				if ('a' <= s[i] && s[i] <= 'z')
					s[i] += 'A' - 'a';
				i++;
			}
		}
	}
	return s;
}

typedef struct KLexer_Elmt_ {
	KInt i;
	const char *p0;
} KLexer_Elmt;

typedef struct KLexer_ {
	KMemPool *mp;
	KInt szElm;
	KStringId *sid, *sid0;
	char *chrTyp, *chrTyp0;
	KVarArea *va, *va0;
	const char *errStr;
} KLexer;

STATIC KInt KLexer_getElmtLen(KLexer *w)
{
	return w->va->s / w->szElm;
}

STATIC KLexer *KLexer_reset(KLexer *w)
{
	w->va->s = 0;
	return w;
}

STATIC KVarArea *KLexer_add(KLexer *w, KInt l, const char *s)
{
	KInt i = 0;
	for (;;) {
		i = ksearchToken0((const unsigned char *) s, i, l, w->chrTyp);
		KInt j = ksearchToken1((const unsigned char *) s, i, l, w->chrTyp);
		if (j == -1) break;
		if (j == -2) {
			w->errStr = &s[i];
			return 0;
		}
		KLexer_Elmt *e = (KLexer_Elmt *) KVarArea_reserve1(w->va, w->szElm);
		e->i = KStringId_getId1L(w->sid, j - i, &s[i]);
		e->p0 = &s[i];
		i = j;
	}
	return w->va;
}

STATIC KLexer *KLexer_addCont(KLexer *w, KInt l, const char *s)
{
	KLexer_add(w, l, s);
	return w;
}

STATIC KInt KLexer_getConstInt(KLexer *w, KInt i)
{
	KStringId_Elmt *e = KStringId_getStr(w->sid, i);
	if (e != 0)
		return (KInt) kstrtoUInt(e->l, e->p, 0, 0);
	return 0;
}

STATIC KInt KLexer_testConstInt(KLexer *w, KInt i)
{
	KStringId_Elmt *e = KStringId_getStr(w->sid, i);
	if (e != 0 && '0' <= e->p[0] && e->p[0] <= '9')
		return -1;
	return 0;
}

STATIC KLexer *KLexer_init(KLexer *w, KMemPool *mp, int szElm, KStringId *sid, char *chrTyp, KVarArea *va)
{
	w = KMemPool_allocP0(mp, sizeof (KLexer), w);
	w->mp = mp;
	w->sid = w->sid0 = sid;
	w->szElm = szElm;
	w->chrTyp = w->chrTyp0 = chrTyp;
	w->va = w->va0 = va;
	w->errStr = 0;	
	if (sid == 0)
		w->sid = KStringId_init(0, mp, 1, 0, 0, 0);
	if (chrTyp == 0)
		w->chrTyp = kinitChrTyp(KMemPool_alloc(mp, 256 * sizeof (char)));
	if (va == 0)
		w->va = KVarArea_init(0, w->mp, 0);
	return w;
}

STATIC void *KLexer_dest(KLexer *w)
{
	if (w->sid0 == 0)
		KStringId_destFr(w->sid);
	if (w->chrTyp0 == 0)
		KMemPool_free(w->mp, 256 * sizeof (char), w->chrTyp);
	if (w->va0 == 0)
		KVarArea_destFr(w->va);
	return w;
}

STATIC void KLexer_destFr(KLexer *w)
{
	KMemPool_free(w->mp, sizeof (KLexer), KLexer_dest(w));
}

STATIC KLexer *KLexer_initAd(KLexer *w, KMemPool *mp, int szElm, KStringId *sid, char *chrTyp, KVarArea *va)
{
	w = KLexer_init(w, mp, szElm, sid, chrTyp, va);
	KMemPool_addDest(mp, KLexer_dest, w, 0);
	return w;
}

STATIC KLexer *KLexer_initAr(KMemPool *mp, int szElm, KStringId *sid, char *chrTyp, KVarArea *va)
{
	KLexer *w = KLexer_init(0, mp, szElm, sid, chrTyp, va);
	KMemPool_addDest(mp, KLexer_destFr, w, 0);
	return w;
}

//////////////////////////////////////////////////////////////////////////////// KSrc

typedef struct KSrcLine_ {
	KInt ln;
	KVarArea src;
} KSrcLine;

STATIC KSrcLine *KSrcLine_init(KSrcLine *w, KMemPool *mp)
{
	w = KMemPool_allocP0(mp, sizeof (KSrcLine), w);
	KVarArea_init(&w->src, mp, 0);
	return w;
}

STATIC void *KSrcLine_dest(KSrcLine *w)
{
	KVarArea_dest(&w->src);
	return w;
}

STATIC void KSrcLine_destFr(KSrcLine *w)
{
	KMemPool_free(w->src.mp, sizeof (KSrcLine), KSrcLine_dest(w));
}

typedef struct KSrc_ {
	KIndexS ln;
	void *opt;	// gp̂܂.
} KSrc;

STATIC KInt KSrc_cmp(KSrcLine *a, KSrcLine *b)
{
	return a->ln - b->ln;
}

STATIC KSrc *KSrc_init(KSrc *w, KMemPool *mp)
{
	w = KMemPool_allocP0(mp, sizeof (KSrc), w);
	KIndexS_init(&w->ln, mp, KSrc_cmp, 0, 0);
	return w;
}

STATIC KSrc *KSrc_delAll(KSrc *w);

STATIC void *KSrc_dest(KSrc *w)
{
	KSrc_delAll(w);
	KIndexS_dest(&w->ln);
	return w;
}

STATIC void KSrc_destFr(KSrc *w)
{
	KMemPool_free(w->ln.va.mp, sizeof (KSrc), KSrc_dest(w));
}

STATIC KSrc *KSrc_initAd(KSrc *w, KMemPool *mp)
{
	w = KSrc_init(w, mp);
	KMemPool_addDest(mp, KSrc_dest, w, 0);
	return w;
}

STATIC KSrc *KSrc_initAr(KMemPool *mp)
{
	KSrc *w = KSrc_init(0, mp);
	KMemPool_addDest(mp, KSrc_destFr, w, 0);
	return w;
}

STATIC KInt KSrc_delLineLn(KSrc *w, KInt l)
{
	KInt i, cr;
	i = KIndexS_search(&w->ln, &l, &cr);
	if (cr == 0) {
		KSrcLine_destFr(*(KSrcLine **) &w->ln.va.p[i]);
		KVarArea_delPtrIdx0(&w->ln.va, i);
		return 0;
	}
	return -1;
}

STATIC KInt KSrc_delLineIdx(KSrc *w, KInt i)
{
	if (i < KVarArea_sizPtr(&w->ln.va)) {
		KSrcLine_destFr((KSrcLine *) KVarArea_getPtrIdx(&w->ln.va, i));
		KVarArea_delPtrIdx(&w->ln.va, i);
		return 0;
	}
	return -1;
}

STATIC KSrc *KSrc_delAll(KSrc *w)
{
	while (w->ln.va.s > 0) {
		KInt i = w->ln.va.s - sizeof (KSrcLine *);
		KSrcLine_destFr(*(KSrcLine **) &w->ln.va.p[i]);
		KVarArea_delPtrIdx0(&w->ln.va, i);
	}
	return w;
}

STATIC KSrc *KSrc_insLine(KSrc *w, KInt l, KInt s, const char *p)
{
	KSrc_delLineLn(w, l);
	KSrcLine *sl = KSrcLine_init(0, w->ln.va.mp);
	sl->ln = l;
	KVarArea_addBytes(&sl->src, s, p);
	KIndexS_ins(&w->ln, sl);
	return w;
}

STATIC KSrc *KSrc_editLine(KSrc *w, KInt s, const char *p)
{
	const char *p1 = p + s;
	KInt l = strtoull(p, (char **) &p, 10);
	KSrc_delLineLn(w, l);
	if (*p == ' ')
		p++;
	if (*p != '\n')
		KSrc_insLine(w, l, p1 - p, p);
	return w;
}

//////////////////////////////////////////////////////////////////////////////// kputBin

STATIC KInt kputBin86vx(unsigned char *q, void *f, void *w, const char *s, va_list ap)
// ̊֐x86/x64ɓ@\.
{
	KInt c = 0;
	static unsigned char *rx = 0;	// staticɂ̂̓X}[gł͂ȂAЂƂ܂͂ł.
	while (*s != 0) {
		if (*s == ' ' || *s == '\t' || *s == '_' || *s == ':') {
			s++;
		} else if (*s != '%') {
			q[c++] = strtol(s, (char **) &s, 16);
		} else if (strncmp(s, "%i8", 3) == 0 && (s[3] <= ' ' || s[3] == '_' || s[3] == ':')) {
			q[c++] = va_arg(ap, int);
			s += 3;
		} else if (strncmp(s, "%i16", 4) == 0 && (s[4] <= ' ' || s[4] == '_' || s[4] == ':')) {
			int i = va_arg(ap, int);
			q[c++] =  i        & 0xff;
			q[c++] = (i >>  8) & 0xff;
			s += 2;
		} else if (strncmp(s, "%i32", 4) == 0 && (s[4] <= ' ' || s[4] == '_' || s[4] == ':')) {
			KInt i = va_arg(ap, KInt);
			q[c++] =  i        & 0xff;
			q[c++] = (i >>  8) & 0xff;
			q[c++] = (i >> 16) & 0xff;
			q[c++] = (i >> 24) & 0xff;
			s += 4;
#if (defined(KUSE64))
		} else if (strncmp(s, "%i64", 4) == 0 && (s[4] <= ' ' || s[4] == '_' || s[4] == ':')) {
			KInt i = va_arg(ap, KInt);
			q[c++] =  i        & 0xff;
			q[c++] = (i >>  8) & 0xff;
			q[c++] = (i >> 16) & 0xff;
			q[c++] = (i >> 24) & 0xff;
			q[c++] = (i >> 32) & 0xff;
			q[c++] = (i >> 40) & 0xff;
			q[c++] = (i >> 48) & 0xff;
			q[c++] = (i >> 56) & 0xff;
			s += 4;
#endif
		} else if (strncmp(s, "%iUS", 4) == 0 && (s[4] <= ' ' || s[4] == '_' || s[4] == ':')) {
			KInt i = va_arg(ap, KInt);
			q[c++] =  i        & 0xff;
			q[c++] = (i >>  8) & 0xff;
			q[c++] = (i >> 16) & 0xff;
			q[c++] = (i >> 24) & 0xff;
#if (defined(KUSE64))
			q[c++] = (i >> 32) & 0xff;
			q[c++] = (i >> 40) & 0xff;
			q[c++] = (i >> 48) & 0xff;
			q[c++] = (i >> 56) & 0xff;
#endif
			s += 4;
		} else if (strncmp(s, "%r32", 4) == 0 && (s[4] <= ' ' || s[4] == '_' || s[4] == ':')) {
			KInt i = va_arg(ap, KInt) - (KInt) &q[c + 4];
			q[c++] =  i        & 0xff;
			q[c++] = (i >>  8) & 0xff;
			q[c++] = (i >> 16) & 0xff;
			q[c++] = (i >> 24) & 0xff;
			s += 4;
		} else if (strncmp(s, "%rx0", 4) == 0 && (s[4] <= ' ' || s[4] == '_' || s[4] == ':')) {
			#if (defined(KUSE64))
				rx = &q[c];
				q[c++] = 0x40;
			#endif
			s += 4;
		} else if (strncmp(s, "%rx1", 4) == 0 && (s[4] <= ' ' || s[4] == '_' || s[4] == ':')) {
			#if (defined(KUSE64))
				rx = &q[c];
				q[c++] = 0x48;
			#endif
			s += 4;
		} else if (strncmp(s, "%mrm", 4) == 0 && (s[4] <= ' ' || s[4] == '_' || s[4] == ':')) {
			int mod = va_arg(ap, int);
			int ttt = va_arg(ap, int);
			int bas = va_arg(ap, int);
			q[c++] = mod << 6 | (ttt & 7) << 3 | (bas & 7);
			#if (defined(KUSE64))
				if (ttt >= 8)
					*rx |= 0x04;
				if (bas >= 8)
					*rx |= 0x01;
			#endif
			s += 4;
		} else if (strncmp(s, "%sib", 4) == 0 && (s[4] <= ' ' || s[4] == '_' || s[4] == ':')) {
			int scl = va_arg(ap, int);
			int idx = va_arg(ap, int);
			int bas = va_arg(ap, int);
			q[c++] = scl << 6 | (idx & 7) << 3 | (bas & 7);
			#if (defined(KUSE64))
				if (idx >= 8)
					*rx |= 0x02;
				if (bas >= 8)
					*rx |= 0x01;
			#endif
			s += 4;
		} else if (strncmp(s, "%cb", 3) == 0 && (s[3] <= ' ' || s[3] == '_' || s[3] == ':')) {
			int cb = va_arg(ap, int);
			int bas = va_arg(ap, int);
			q[c++] = cb | (bas & 7);
			#if (defined(KUSE64))
				if (bas >= 8)
					*rx |= 0x01;
			#endif
			s += 3;
		} else if (strncmp(s, "%m0", 3) == 0 && (s[3] <= ' ' || s[3] == '_' || s[3] == ':')) {
			int ttt = va_arg(ap, int);
			int bas = va_arg(ap, int);
			int dsp = va_arg(ap, int);
			int mod = 2;
			if (dsp == 0 && (bas & 7) != 5)
				mod = 0;
			if (-128 <= dsp && dsp <= 127)
				mod = 1;
			q[c++] = mod << 6 | (ttt & 7) << 3 | (bas & 7);
			#if (defined(KUSE64))
				if (ttt >= 8)
					*rx |= 0x04;
				if (bas >= 8)
					*rx |= 0x01;
			#endif
			if (mod >= 1)
				q[c++] =  dsp        & 0xff;
			if (mod == 2) {
				q[c++] = (dsp >>  8) & 0xff;
				q[c++] = (dsp >> 16) & 0xff;
				q[c++] = (dsp >> 24) & 0xff;
			}
			s += 3;
		} else {
			if (f != 0) {
				const char *ss = ((const char *(*)(void *, const char *, unsigned char *, KInt *, va_list *, unsigned char *)) f)(w, s, q, &c, &ap, rx);
				if (ss != 0) {
					s = ss;
					continue;
				}
			}
			kerrorExit("kputBin86: error: '%.20s'", s);
		}
	}
	return c;
}

STATIC KInt kputBin86x(unsigned char *q, void *f, void *w, const char *s, ...)
{
    va_list ap;
    va_start(ap, s);
	KInt i = kputBin86vx(q, f, w, s, ap);
	va_end(ap);
	return i;
}

STATIC KInt kputBin86(unsigned char *q, const char *s, ...)
{
    va_list ap;
    va_start(ap, s);
	KInt i = kputBin86vx(q, 0, 0, s, ap);
	va_end(ap);
	return i;
}

#if (defined(KWINDOWS))

STATIC void *kmallocRWX(KInt siz)
{
	return VirtualAlloc(0, siz, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
}

#elif (defined(KPOSIX))

STATIC void *kmallocRWX(KInt siz)
{
	void *p = mmap(NULL, siz, PROT_READ | PROT_WRITE | PROT_EXEC,
		       MAP_ANONYMOUS | MAP_PRIVATE, -1, 0);
	return p;
}

#endif

//////////////////////////////////////////////////////////////////////////////// KPhraseCmp

typedef struct KPhraseCmp_ {
	KMemPool *mp;	// codê.
	KInt *code, l0, l1, prI0, prI1, *prPos, fpc;
	KStringId *sid;
	const char *chrTyp;
	KInt (*func)(KInt, KInt, struct KPhraseCmp_ *);
	KLexer_Elmt *prLe, *fle;
} KPhraseCmp;

STATIC KPhraseCmp *KPhraseCmp_init(KPhraseCmp *w, KMemPool *mp, KInt l0, KInt l1, KStringId *sid, const char *ct, KInt (*func)(KInt, KInt, KPhraseCmp *))
{
	w = KMemPool_allocP0(mp, sizeof (KPhraseCmp), w);
	w->mp = mp;
	w->l0 = l0;
	w->l1 = l1;
	w->sid = sid;
	w->chrTyp = ct;
	w->func = func;
	w->code = KMemPool_allocC(mp, l0 * l1 * sizeof (KInt));
	return w;
}

STATIC void *KPhraseCmp_dest(KPhraseCmp *w)
{
	KMemPool_free(w->mp, w->l0 * w->l1 * sizeof (KInt), w->code);
	return w;
}

STATIC void KPhraseCmp_destFr(KPhraseCmp *w)
{
	KMemPool_free(w->mp, sizeof (KPhraseCmp), KPhraseCmp_dest(w));
}

STATIC KPhraseCmp *KPhraseCmp_initAd(KPhraseCmp *w, KMemPool *mp, KInt l0, KInt l1, KStringId *sid, const char *ct, KInt (*func)(KInt, KInt, KPhraseCmp *))
{
	w = KPhraseCmp_init(w, mp, l0, l1, sid, ct, func);
	KMemPool_addDest(mp, KPhraseCmp_dest, w, 0);
	return w;
}

STATIC KPhraseCmp *KPhraseCmp_initAr(KMemPool *mp, KInt l0, KInt l1, KStringId *sid, const char *ct, KInt (*func)(KInt, KInt, KPhraseCmp *))
{
	KPhraseCmp *w = KPhraseCmp_init(0, mp, l0, l1, sid, ct, func);
	KMemPool_addDest(mp, KPhraseCmp_destFr, w, 0);
	return w;
}

STATIC KInt KPhraseCmp_cmpGrp(KPhraseCmp *w, KInt k, KInt i);

STATIC KInt KPhraseCmp_cmp(KPhraseCmp *w, KInt k, const char *s, KLexer_Elmt *le, KInt *pos, KInt i0, KInt i1)
{
	KInt *ic = &w->code[k * w->l0];
	KInt i, l, c, ii, bc[8], sk = -0x7fffffff;
	if (ic[w->l0 - 1] != (KInt) s) {
		if (ic[w->l0 - 1] != 0)
			kerrorExit("KPhraseCmp: internal error (k=%d)", (int) k);
		ic[w->l0 - 1] = (KInt) s;
		c = *s++;
		const char *s1 = s + strlen(s);
		for (i = 0; ; i++) {
			s += ksearchToken0((const unsigned char *) s, 0, s1 - s, w->chrTyp);
			if (*s == '\0') break;
			l = ksearchToken1((const unsigned char *) s, 0, s1 - s, w->chrTyp);
			if (*s != c) {
				ic[i] = KStringId_getId1L(w->sid, l, s);
			} else {
				if (l == 3 && strncmp(s + 1, "ex", 2) == 0)
					ic[i] = -3;
				else if (l == 2 && strncmp(s + 1, "t", 1) == 0)
					ic[i] = -2;
				else if (l == 3 && strncmp(s + 1, "cs", 2) == 0)
					ic[i] = -4;
				else if (s[1] == '_') {
					ic[i] = -5;
					i++;
					s += 2;
					l = ksearchToken1((const unsigned char *) s, 0, s1 - s, w->chrTyp);
					ic[i] = KStringId_getId1L(w->sid, l, s);
				} else if (l == 4 && strncmp(s + 1, "ex_", 3) == 0)
					ic[i] = -6;
				else if (l == 3 && strncmp(s + 1, "t_", 2) == 0)
					ic[i] = -7;
				else if (l >= 3 && s[1] == '#')
					ic[i] = -0x10000000 - kstrtoUInt(l - 2, s + 2, 0, 10);
				else {	// g.
					w->fpc = l;
					ic[i] = w->func(2, (KInt) s, w);
				}
			}
			s += l;
		}
		ic[i] = -1;
	}
	l = ii = 0;
	for (i = 0; i < 8; i++)
		bc[i] = 0;
	if (pos != 0) {
		for (i = 0; i < 16; i++)
			pos[i] = -0x7fffffff;
	}
	for (i = i0; ; ii++) {
		if (ic[ii] == -1)
			return -1;
		if (i >= i1) return 0;
		if (le[i].i == sk) {
			while (ic[ii] != sk) {
				if (ic[ii] == -1)
					return 0;
				ii++;
			}
			i++;
			continue;
		}
		if (ic[ii] >= 0) {
			if (le[i].i == ic[ii]) {
				i++;
				continue;
			}
			return 0;
		}
		if (ic[ii] == -5) {
			ii++;
			sk = ic[ii];
			continue;
		}
		if ((ic[ii] == -7 || ic[ii] == -6) && ic[ii + 1] == le[i].i) {
			l += 2;
			continue;
		}
		if (pos != 0)
			pos[l++] = i;
		if (ic[ii] == -2 || ic[ii] == -7)
			i++;
		if (ic[ii] == -3 || ic[ii] == -6) {
			int i0_ = i;
			for (; ; i++) {
				if (i >= i1) return 0;
				c = w->func(0, le[i].i, w);
				if (c >= 0) {
					if ((c & 16) == 0)
						bc[c]++;
					else {
						if (bc[c & 15] > 0)
							bc[c & 15]--;
						else
							break;
					}
				}
				c = bc[0] + bc[1] + bc[2] + bc[3] + bc[4] + bc[5] + bc[6] + bc[7];
				if (c == 0) {
					if (w->func(1, le[i].i, w) != 0)
						break;
					if (le[i].i == ic[ii + 1])
						break;
				}
			}
			if (ic[ii] == -3 && i == i0_) return 0;
		}
		if (ic[ii] == -4) {
			// p0QƂׂł͂Ȃ.
			c = KStringId_getStr(w->sid, le[i].i)->p[0];
			if (c != 0x22 && c != 0x27)
				return 0;
			i++;
		}
		if (ic[ii] <= -0x10000000) {
			KInt kk = -0x10000000 - ic[ii];
			kk = KPhraseCmp_cmpGrp(w, kk, le[i].i);
			if (kk < 0) return 0;
			i++;
			if (pos != 0)
				pos[l++] = kk;
			continue;
		}
		if (ic[ii] <= -256) {
			w->fpc = i;
			w->fle = le;
			c = w->func(3, ic[ii], w);
			if (c < 0) return 0;
			i += c;
		}
		if (pos != 0)
			pos[l++] = i;
	}
}

STATIC KPhraseCmp *KPhraseCmp_setPr(KPhraseCmp *w, KLexer_Elmt *le, KInt *pos, KInt i0, KInt i1)
{
	w->prLe = le;
	w->prPos = pos;
	w->prI0 = i0;
	w->prI1 = i1;
	return w;
}

STATIC KInt KPhraseCmp_cmpPr(KPhraseCmp *w, KInt k, const char *s)
{
	return KPhraseCmp_cmp(w, k, s, w->prLe, w->prPos, w->prI0, w->prI1);
}

STATIC void KPhraseCmp_setGrp(KPhraseCmp *w, KInt k, const char *s)
{
	KInt *ic = &w->code[k * w->l0];
	KInt l, i = 0;
	const char *s1 = s + strlen(s);
	for (;;) {
		s += ksearchToken0((const unsigned char *) s, 0, s1 - s, w->chrTyp);
		if (*s == '\0') break;
		l = ksearchToken1((const unsigned char *) s, 0, s1 - s, w->chrTyp);
		ic[i] = KStringId_getId1L(w->sid, l, s);
		s += l;
		i++;
	}
	ic[i] = -1;
}

STATIC KInt KPhraseCmp_cmpGrp(KPhraseCmp *w, KInt k, KInt i)
{
	KInt *ic = &w->code[k * w->l0];
	KInt j = 0;
	while (ic[j] >= 0) {
		if (ic[j] == i) return j;
		j++;
	}
	return -1;
}
