#include <stddef.h>
//#include <string.h>

STATIC char *strchr(const char *s, int c)
{
	while (*s != '\0') {
		if (*s == c) return (char *) s;
		s++;
	}
	return 0;
}

STATIC void qsort_sub(char *bas, int n1s, int siz, int (*cmp)(const void *, const void *))
{
	int i;
	if (n1s <= 0) return; // N=1
	char *bi = bas, *bj = bas + n1s, *bk, c;
	if (n1s == siz) {	// N=2
		if (cmp(bi, bj) > 0) {
			for (i = 0; i < siz; i++) { c = bi[i]; bi[i] = bj[i]; bj[i] = c; }
		}
		return;
	}
#if 0	// ̕KvȂ΁A͏ȗĂ悢.
	if (n1s == siz * 2) {	// N=3
		bk = bas + siz;
		if (cmp(bi, bk) <= 0) {
			if (cmp(bk, bj) <= 0)
				return; // i<k<j
			if (cmp(bj, bi) <= 0) {
				for (i = 0; i < siz; i++) { c = bi[i]; bi[i] = bj[i]; bj[i] = bk[i]; bk[i] = c; }
				return; // j<i<k
			}
			for (i = 0; i < siz; i++) { c = bk[i]; bk[i] = bj[i]; bj[i] = c; }
			return; // i<j<k
		}
		if (cmp(bj, bk) <= 0) {
			for (i = 0; i < siz; i++) { c = bi[i]; bi[i] = bj[i]; bj[i] = c; }
			return; // j<k<i
		}
		if (cmp(bi, bj) <= 0) {
			for (i = 0; i < siz; i++) { c = bi[i]; bi[i] = bk[i]; bk[i] = c; }
			return; // k<i<j
		}
		for (i = 0; i < siz; i++) { c = bi[i]; bi[i] = bk[i]; bk[i] = bj[i]; bj[i] = c; }
		return; // s<n<0
	}
#endif
	bk = bas + (n1s / (siz * 2)) * siz;
	if (cmp(bi, bk) <= 0) {
		if (cmp(bk, bj) <= 0)
			goto skip; // i<k<j
		if (cmp(bj, bi) <= 0) {
			bk = bi;
			goto skip;	// j<i<k
		}
		bk = bj;
		goto skip; // i<j<k
	}
	if (cmp(bj, bk) <= 0)
		goto skip; // j<k<i
	if (cmp(bi, bj) <= 0) {
		bk = bi;
		goto skip; // k<i<j
	}
	bk = bj;
//	goto skip; // k<j<i
skip:
	for (;;) {
		while (cmp(bi, bk) < 0) bi += siz;
		while (cmp(bk, bj) < 0) bj -= siz;
		if (bi >= bj) break;
		for (i = 0; i < siz; i++) { c = bi[i]; bi[i] = bj[i]; bj[i] = c; }
		if (bk == bi)
			bk = bj;
		else if (bk == bj)
			bk = bi;
		bi += siz;
		bj -= siz;
	}
	qsort_sub(bas, bi - bas - siz, siz, cmp);
	qsort_sub(bj + siz, n1s - (bj - bas + siz), siz, cmp);
}

STATIC void qsort(void *base, size_t num, size_t size, int (*compare)(const void *, const void *))
{
	qsort_sub(base, (num - 1) * size, size, compare);
}

STATIC void exit(int i)
{
	api_end();
}

typedef int clock_t;

typedef struct FILE_ {
	int fh;
} FILE;

#define stdin	((FILE *) -1)
#define stdout	((FILE *) -2)
#define stderr	((FILE *) -3)

#define EXIT_FAILURE	1
typedef unsigned int uint32_t;
typedef unsigned short uint16_t;
typedef unsigned char uint8_t;
STATIC void *malloc(int sz) { return api_malloc(sz); }
STATIC void freews(void *p, int sz) { api_free(p, sz); }	// free with size
#define SEEK_SET 0
STATIC void *kmallocRWX(int sz) { return api_malloc(sz); }

STATIC struct HrbCons *hcons;

STATIC int strtoull(const char *s, char **endp, int base)
{
	int i = 0, j, sgn = 1;
	while (*s == ' ' || *s == '\t') s++;
	if (*s == '+') s++;
	if (*s == '-') { s++; sgn = -1; }
	if (base == 0) {
		if (*s == '0') {
			if (s[1] == 'X' || s[1] == 'x') {
				base = 16;
				s += 2;
				goto skip;
			}
			base = 10;
		}
	}
skip:
	for (;;) {
		j = -1;
		if ('0' <= *s && *s <= '9') j = *s - '0';
		if ('A' <= *s && *s <= 'Z') j = *s - ('A' - 10);
		if ('a' <= *s && *s <= 'z') j = *s - ('a' - 10);
		if (j < 0 || j >= base) break;
		i = i * base + j;
		s++;
	}
	if (endp != 0)
		*endp = (char *) s;
	return i * sgn;
}

STATIC int snprintf(char *s, int n, const char *fmt, ...);

STATIC int vsnprintf(char *s, int n, const char *fmt, va_list arg)
{
	int i = 0, j, k, l, i0, c, p0, p1, p2, n1 = n - 1;
	while ((c = *fmt++) != '\0') {
		if (c != '%') {
put:
			if (i < n1)
				s[i++] = c;
			continue;
		}
		c = *fmt;
		if (c == '%') {
			fmt++;
			goto put;
		}
		p0 = 0;
		for (;;) {
			c = *fmt;
			if (c == '0') { p0 |=  1; fmt++; continue; }
			if (c == ' ') { p0 |=  2; fmt++; continue; }
			if (c == '+') { p0 |=  4; fmt++; continue; }
			if (c == '-') { p0 |=  8; fmt++; continue; }
			if (c == '#') { p0 |= 16; fmt++; continue; }
			break;
		}
		if (*fmt == '*') {
			p1 = va_arg(arg, int);
			fmt++;
		} else
			p1 = strtoull(fmt, (char **) &fmt, 10);
		p2 = -1;
		if (*fmt == '.') {
			fmt++;
			if (*fmt == '*') {
				p2 = va_arg(arg, int);
				fmt++;
			} else
				p2 = strtoull(fmt, (char **) &fmt, 10);
		}
		c = *fmt++;
		i0 = i;
		if (c == 'd' || c == 'x' || c == 'X') {
			j = va_arg(arg, int);
			k = 0;
			if (j > 0 && (p0 & 4) != 0) {
				if (i < n1)
					s[i++] = '+';
			}
			if (j < 0) {
				if (i < n1)
					s[i++] = '-';
				j *= -1;
			}
			k = i;
			if (j == 0) {
				if (i < n1)
					s[i++] = '0';
			}
			while (j > 0) {
				for (l = i; l > k; l--) {
					if (l < n1)
						s[l] = s[l - 1];
				}
				i++;
				if (c == 'd') {
					s[k] = (j % 10) + '0';
					j /= 10;
				} else {
					s[k] = (j & 0xf) + '0';
					if (s[k] > '9') {
						s[k] += 'A' - ('9' + 1);
						if (c == 'x')
							s[k] += 'a' - 'A';
					}
					j >>= 4;
				}
			}
			c = ' ';
			if ((p0 & 1) != 0)
				c = '0';
			while (i - i0 < p1) {
				for (l = i; l > k; l--) {
					if (l < n1)
						s[l] = s[l - 1];
				}
				i++;
				s[k] = c;
			}
			continue;
		}
		if (c == 's') {
			if (p2 < 0) p2 = 0x7fffffff;
			char *p = va_arg(arg, char *);
			l = 0;
			while (p[l] != '\0' && l < p2) l++;
			if (l < p1) {
				if ((p0 & 8) == 0) {
					for (j = p1 - l; j > 0; j--) {
						if (i < n1)
							s[i++] = ' ';
					}
				}
				for (j = 0; j < l; j++) {
					if (i < n1)
						s[i++] = p[j];
				}
				if ((p0 & 8) != 0) {
					for (; j < p1; j++) {
						if (i < n1)
							s[i++] = ' ';
					}
				}
				continue;
			}
			for (j = 0; j < l; j++) {
				if (i < n1)
					s[i++] = p[j];
			}
			continue;
		}
		if (c == 'f') {
			double d = va_arg(arg, double);
			j = d;
			i += snprintf(&s[i], n1 - i, "%d.", j);
			if (d >= 0)
				d = d - (double) j;
			else
				d = j - d;
			for (l = 0; l < p2; l++)
				d *= 10.0;
			i += snprintf(&s[i], n1 - i, "%0*d", p2, (int) d);
		}
		if (c == 'c') {
			j = va_arg(arg, int);
			if (i < n1)
				s[i++] = j;
			continue;
		}
	}
	s[i] = '\0';
	return i;
}

STATIC int snprintf(char *s, int n, const char *fmt, ...)
{
	va_list arg;
	va_start(arg, fmt);
	int i = vsnprintf(s, n, fmt, arg);
	va_end(arg);
	return i;
}

STATIC int fprintf(FILE *fp, const char *fmt,...)
{
	char s[4096];
	va_list arg;
	va_start(arg, fmt);
	int i = vsnprintf(s, sizeof s, fmt, arg);
	if (fp == stdout || fp == stderr)
		hrbCons_puts(hcons, s, i);
	va_end(arg);
	return i;
}

STATIC int vfprintf(FILE *fp, const char *fmt, va_list arg)
{
	char s[4096];
	int i = vsnprintf(s, sizeof s, fmt, arg);
	if (fp == stdout || fp == stderr)
		hrbCons_puts(hcons, s, i);
	return i;
}

STATIC int printf(const char *fmt,...)
{
	char s[4096];
	va_list arg;
	va_start(arg, fmt);
	int i = vsnprintf(s, sizeof s, fmt, arg);
	hrbCons_puts(hcons, s, i);
	va_end(arg);
	return i;
}

STATIC int puts(const char *s)
{
	int i = strlen(s);
	hrbCons_puts(hcons, s, i);
	hrbCons_puts(hcons, "\n", 1);
	return i + 1;
}

STATIC int fputs(const char *s, FILE *fp)
{
	int i = strlen(s);
	if (fp == stdout || fp == stderr)
		hrbCons_puts(hcons, s, i);
	return i;
}

STATIC int putchar(int c)
{
	hrbCons_puts(hcons, (char *) &c, 1);
	return c;
}

STATIC int hrbTimer;
void *hrb_keywin;

STATIC void hrbStartup()
{
	api_semiFlat();
	api_initmalloc();
	hrbTimer = api_alloctimer();
	api_inittimer(hrbTimer, 0x10000);
	api_settimer(hrbTimer, 4);
	hcons = hrbCons_open(0, 0, 100, 35, "esb02b");
}

STATIC FILE *fopen(const char *path, const char *mod)
{
	FILE *fp = 0;
	int fh = api_fopen((char *) path);
	if (fh != 0) {
		fp = (FILE *) api_malloc(sizeof (FILE));
		fp->fh = fh;
	}
	return fp;
}

STATIC int fclose(FILE *fp)
{
	if (fp != 0)
		api_free((char *) fp, sizeof (FILE));
	return 0;
}

STATIC int fwrite(const char *buf, int siz, int n, FILE *fp)
{
	if (fp == stdout || fp == stderr)
		hrbCons_puts(hcons, buf, siz * n);
	return n;
}

STATIC int fread(char *buf, int siz, int n, FILE *fp)
{
	return api_fread(buf, siz * n, fp->fh);
}

STATIC int feof(FILE *fp)
{
	if (api_fsize(fp->fh, 2) < 0) return 0;
	return -1;
}

STATIC int fseek(FILE *fp, int ofs, int org)
{
	if (org == SEEK_SET) {
		api_fseek(fp->fh, ofs, 0);
		return 0;
	}
	hrbCons_puts(hcons, "\nfseek: mikan\n", 99);
	exit(1);
	return 0;	// dummy
}

STATIC void es_sysBreak(int f);

STATIC void hrbCheckSigBox(int f)
{
	for (;;) {
		int i = api_getkeyEx(f);
		if (i == -1) return;
		f = 0;
		if (i == 0x10000) {	// 40msƂɋAĂ邽߂̎dg.
			api_settimer(hrbTimer, 4);
			continue;
		}
		if (hrb_keywin != 0) {
			int sh0 = (i >> 8) & 0xf, sh1 = (i >> 12) & 0xf;
			i &= 0xff;
			if (i >= 0x80) i += 0x1020 - 0x80;
			if (i == 0x1023 && ((sh0 | sh1) & 1) != 0)
				es_sysBreak(2);	// Shift+HOMEoătOɔf.
			else
				putKeybuf(hrb_keywin, i | sh0 << 16 | sh1 << 24);
		}
	}
}

STATIC char *fgets(char *s, int n, FILE *fp)
{
	int i = 0, c;
	if (fp != stdin) return 0;
	for (;;) {
		hrbCons_needRefresh(hcons);
		hrbCons_putCur(hcons, 1);
		for (;;) {
			hrbCheckSigBox(0);
			c = bla_inkey(hrb_keywin) & 0xfffff;
			if (c != 0) break;
			hrbCheckSigBox(1);
		}
		hrbCons_putCur(hcons, 0);
		if (c == '\n') break;
		if (c == '\b') {
			if (i > 0) {
				i--;
				hrbCons_puts(hcons, "\b", 1);
			}
			continue;
		}
		if (c == '\t') continue;
		if (i < n - 2) {
			hrbCons_puts(hcons, (char *) &c, 1);
			s[i++] = c;
		}
	}
	hrbCons_puts(hcons, "\n", 1);
	s[i] = '\n';
	s[i + 1] = '\0';
	hcons->needRefresh = 1;	// RgAEgƃR\[̕`悪mɂȂ邪xȂ.
	return s;
}

STATIC int scanf(const char *s, int *ip)
// "%d"p.
{
	if (strcmp(s, "%d") != 0) {
		hrbCons_puts(hcons, "\nscanf: mikan\n", 99);
		exit(1);
	}
	char ss[4096], *t;
	do {
		fgets(ss, sizeof ss, stdin);
		ss[4095] = 0;
		*ip = strtoull(ss, &t, 0);
	} while (t <= ss);
	return 1;
}

#define CLOCKS_PER_SEC	1000

#define time clock

int clock()
{
	return api_getTimeCount() * 10;
}

int hrbSleepTime;	// 	{envlƂɂ̒lׂ.

STATIC void hrbSleep(int msec)
{
	hrbSleepTime += msec;
	hrbCheckSigBox(0);	// L[͂Ȃǂ荞.
	while (clock() < hrbSleepTime)
		hrbCheckSigBox(1);
}

STATIC int hrbGetArgs(char **argv)
{
	char *s = api_malloc(4096);
	api_cmdline(s, 4096);
	int c = 0;
	for (;;) {
		while (*s == '\t' || *s == ' ') s++;
		if (*s == '\0') break;
		if (*s != 0x22) {
			argv[c++] = s;
			while (*s != '\t' && *s != ' ' && *s != '\0') s++;
		} else {
			s++;
			argv[c++] = s;
			while (*s != 0x22 && *s != '\0') s++;
		}
		if (*s != '\0')
			*s++ = '\0';
	}
	argv[c] = 0;
	return c;
}

#if 0

c̉ۑF
	fgetsShift+HomeƂ͂ǂ邩H
	͂i߂(Ok)ɂȂB


#endif

